from gru import *

def test():
    saved_data = np.load("data.npy")
    data   = saved_data[()]['data']
    hidden = saved_data[()]['hidden']
    delta  = saved_data[()]['delta']
    
    solution = np.load("solution.npy")

    input_dim = 5
    hidden_dim = 2
    seq_len = 10

    g1 = GRU_Cell(input_dim, hidden_dim)
    
    o1 = g1.forward(data[0], hidden)
    o2 = solution[()]['forward']
 
    assert(np.allclose(o1, o2, atol=1e-2, rtol=1e-2))
    print("forward: PASSED")
    delta = delta.reshape(1, -1)

    dx1, dhlast1 = g1.backward(delta)
    dx2, dhlast2 = solution[()]['dx'], solution[()]['dhlast']

    assert(np.allclose(dx1, dx2, atol=1e-2, rtol=1e-2))
    assert(np.allclose(dhlast1, dhlast2, atol=1e-2, rtol=1e-2))
    print("backward: PASSED")

if __name__ == '__main__':
    test()
